import ldap

class LDAPSearcher():
	def __init__(self):
		"""Bind to the Texas A&M LDAP server."""
		server = "operator.tamu.edu"
		who = ""
		cred = ""
		self.l = ldap.open(server)
		self.l.simple_bind(who, cred)
		#print "bound successfully"

	def lookup(self,username=""):
		"""Look up person with netid <username> and return a dictionary of relevant attributes."""
		base = ""
		scope = ldap.SCOPE_SUBTREE
		filter = ""
		try:
			uin = int(username)
			filter = "tamuEduPersonUIN=" + username
		except:
			filter = "tamuEduPersonNetID=" + username
		retrieve_attributes = ["tamuEduPersonNetID", "sn", "givenName", "mail", "major", "classification"]
		count = 0
		result_set = []
		all = 0
		timeout = 5.0
		toreturn = {}
		#print "searching"
		result_id = self.l.search(base, scope, filter, retrieve_attributes)
		while True:
			try:
				result_type, result_data = self.l.result(result_id, all, timeout)
				if (result_data == []):
					break
				else:
					if result_type == ldap.RES_SEARCH_ENTRY:
						result_set.append(result_data)
			except ldap.TIMEOUT:
				return { "netid" : username }
		if len(result_set) == 0:
		#	print "No matching NetID"
			return {}
		toreturn["netid"] = username
		for i in range(len(result_set)):
			for entry in result_set[i]:
				for attr in retrieve_attributes:
					try:
						if entry[1][attr][0] == "":
							continue;
		#				print attr,"=",entry[1][attr][0]
						toreturn[attr] = entry[1][attr][0]
					except:
						pass
		#print result_set
		return toreturn

if __name__ == "__main__":
	a = LDAPSearcher()
	print a.lookup("drew.m.fisher")


